;--- Copyright (C) Sergei Frolov, 2002
;--- frs@overlink.ru    http://go.to/Frolov

;---     ---

;=================  ==================
;=================================================

;===============================================
;---      (ZL)
;--- 1-,2- :  -
;--- 3- :  
SHOW_TEXT:
	lpm	XL, Z+
	lpm	XH, Z+
	lpm	r17, Z+
st_1:	lpm	r16, Z+
	st	X+, r16
	dec	r17
	brne	st_1
	ret

;===============================================
;---  
CLEAR_SCREEN:
	movw	ZL, CLS_CNT
	ldi	r16, 0x20
CLE_2:ldi	XL, 0x3			; 1
cle_1:st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	dec	XL				; 1
	brne	cle_1				; 2/1
	cpi	ZH, 4
	brlo	cle_3
	cbr	bitmap1, 1 << CLRSCR
cle_3:movw	r6, ZL			; 1
	eor	r6, const_0			; 1
	nop					; 1
	nop					; 1
	nop					; 1
	nop					; 1
	ret					; 3

;===============================================
;---  
CLS:
	ldi	r16, 0x20			; 1
	ldi	ZL, low(VIDEO_RAM)	; 1
	ldi	ZH, high(VIDEO_RAM)	; 1
	ldi	r17, 0x13			; 1
cls_1:st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	st	Z+, r16			; 2
	dec	r17				; 1
	brne	cls_1				; 2/1
	ret					; 3

;===============================================
;---    
;--- (6+r21*81)
DELAY_CHECK_INPUTS:
	rcall	CHECK_INPUTS		; 78
	dec	r21				; 1
	brne	DELAY_CHECK_INPUTS	; 2/1
	ret					; 7

;===============================================
;---  76  - 1
DELAY_76:
	ldi	r21, 15
	rcall	DELAY_V
	nop
	ret

;===============================================
;---  38  - 1
DELAY_38:
	ldi	r21, 5
	rcall	DELAY_V
	nop
	nop
	nop
	ret
	
;===============================================
;---  948  - 1
DELAY_948:
	ldi	r21, 11			; 1
	rcall	DELAY_CHECK_INPUTS	; 897
	ldi	r21, 8			; 1
	rcall	DELAY_V			; 
	nop
	nop		
	nop		
	ret

;===============================================
;---  986  - 1
DELAY_986:
	ldi	r21, 11			; 
	rcall	DELAY_CHECK_INPUTS	; 
	ldi	r21, 18
	rcall	DELAY_V
	nop
	ret

;===============================================
;---  436  - 1
DELAY_436:
	ldi	r21, 5			; 1
	rcall	DELAY_CHECK_INPUTS	; 411
	ldi	r21, 2
	rcall	DELAY_V
	nop
	ret

;===============================================
;---  474  - 1
DELAY_474:
	ldi	r21, 5			; 1
	rcall	DELAY_CHECK_INPUTS	; 411
	ldi	r21, 11
	rcall	DELAY_V
	nop
	nop
	nop
	ret

;===============================================
;---  3.25us (52)
;---  r21
DELAY35:
	ldi	r21, 20	; 1
delay:dec	r21		; 1
	brne	delay		; 2/1 16*3-1=47
	nop
	ret			; 7

;===============================================
;---  6+(r21*4) (10..1034)
DELAY_V:
	nop			; 1
	dec	r21		; 1
	brne	DELAY_V	; 2/1
	ret			; 7

;===============================================
;---  (10)
DELAY10T:
	nop			; 1
	nop			; 1
	nop			; 1
	ret			; 7

